#include <stdio.h>
#include <avr/pgmspace.h>

/*The simple Nanonyam example
Select ATMEGA2560 board
Select menu "Sketch\Export compiled binary (Ctrl+Alt+S)"
Run program "Nanonyam\Nanonyam.exe" to run hex-file.
*/

//Including libraries for Nanonyam
#include "nanonyam_libs\nn_system_lib.c"
#include "nanonyam_libs\nn_keyboard_lib.c"
#include "nanonyam_libs\nn_file_lib.c"
#include "nanonyam_libs\nn_math_lib.c"
#include "nanonyam_libs\nn_text_lib.c"
#include "nanonyam_libs\nn_graphics_lib.c"

void setup() {
  sys_Nanonyam();//Need for security
  g_ConfigExternalFont(0,30,1,0,0,0,"Arial");//Select Windows font to font's cell #0
  g_SetExternalFont(0);//Select font's cell #0
  g_CreatePage(0,300,300,0);//Create graphic page #0
  g_SetScreenSize(300,300);//Set screen size 300x300 pixels
  sys_WindowSetText("Example");//Set window title
  g_SetBackRGB(0,0,255);//Set blue background color
  g_SetPenSize(3);//Set line width for drawing
}

void loop() {
  uint8_t i;
  while(1){
    g_ClearAll();//Clear screen
    //Draw some random circles
    for (i=0;i<20;i++){
      g_SetPenColor(g_RandomColor());//Set random color for lines
      //Draw circle with random position and radius
      g_DrawCircle(RandomInterval(-10,310),RandomInterval(-10,310),RandomInterval(5,100));
      };
    g_SetTextRGB(255,255,0);//Set yellow text color
    g_DrawTextCenterX(0,300,0,"Hello, world!");//Write text
    g_SetTextRGB(0,255,0);//Set green text color
    g_DrawTextCenterX(0,300,30,"Welcome to Nanonyam!");//Secon text
    g_Update();//Update screen
    sys_Delay(100);//Delay, sleep processor
    };
}
