/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

//File input and output functions library

#ifndef __nanonyam_file_lib
#define __nanonyam_file_lib

void file_Open(uint8_t id,uint8_t mode,const char* filename);
void file_Close(uint8_t id);
void file_Flush(uint8_t id);
uint32_t file_GetSize(uint8_t id);
void file_Delete(const char* filename);
void file_DeleteDir(const char* dirname);
void file_CreateDir(const char* dirname);
void file_Rename(const char* oldname,const char* newname);
void file_SetCurrentDir(const char* dirname);
void file_GetCurrentDir(uint16_t max,char* dirname);
void file_GetTempDir(uint16_t max,char* dirname);
uint8_t file_Exist(const char* filename);
void file_GetProgramDir(uint16_t max,char* dirname);
void file_GetProgramName(uint16_t max,char* name);
void file_GetCodeDir(uint16_t max,char* dirname);
void file_GetCodePath(uint16_t max,char* pathname);
void file_ToHome(uint8_t id);
void file_ToEnd(uint8_t id);
void file_ToPos(uint8_t id,uint32_t position);
void file_Read(uint8_t id,uint16_t num,uint8_t *data);
void file_Write(uint8_t id,uint16_t num,uint8_t *data);
uint8_t file_ReadU8(uint8_t id);
uint16_t file_ReadU16(uint8_t id);
uint32_t file_ReadU32(uint8_t id);
uint64_t file_ReadU64(uint8_t id);
float file_ReadFLT(uint8_t id);
void file_ReadText(uint8_t id,uint16_t num,char* text);
uint16_t file_ReadTextLine(uint8_t id,uint16_t max,char* text);
void file_WriteU8(uint8_t id,uint8_t data);
void file_WriteU16(uint8_t id,uint16_t data);
void file_WriteU32(uint8_t id,uint32_t data);
void file_WriteU64(uint8_t id,uint64_t data);
void file_WriteFLT(uint8_t id,float data);
void file_WriteText(uint8_t id,const char *text);
void file_WriteTextLine(uint8_t id,const char *text);
#endif /*__nanonyam_file_lib*/
