/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

#include <stdio.h>
#include "nanonyam.h"
#include "nn_system_lib.h"
#include "nn_graphics_lib.h"

//       .
//    .  GetLastError()>0,  .
void g_SetScreenSize(int16_t sizex, int16_t sizey){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=sizex;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=sizey;
	sys_ExecuteByCodes(3,1);
}

//     .
void g_Update(void){
	sys_ExecuteByCodes(3,2);
}

//     .
void g_FillAll(void){
	sys_ExecuteByCodes(3,3);
}

//    .
void g_ClearAll(void){
	sys_ExecuteByCodes(3,4);
}

//       (n=0...3).
void g_SetPage(uint16_t n){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=n;
	sys_ExecuteByCodes(3,5);
}

//      .
void g_SetPen(int16_t size,uint32_t color){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=size;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+2)))=color;
	sys_ExecuteByCodes(3,42);
}

//    .
void g_SetPenSize(int16_t size){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=size;
	sys_ExecuteByCodes(3,6);
}

//     .
int16_t g_GetPenSize(void){
	return (int16_t)sys_ExecuteByCodesU16(3,7);
}

//       .     ,     .
//    g_SetFillColor
void g_SetPenColor(uint32_t color){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=color;
	sys_ExecuteByCodes(3,8);
}

//       .
void g_SetPenRGB(uint8_t red,uint8_t green,uint8_t blue){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=red;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=green;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=blue;
	sys_ExecuteByCodes(3,9);
}


//     .
uint32_t g_GetPenColor(void){
	return sys_ExecuteByCodesU32(3,10);
}

//   .
void g_SetFillColor(uint32_t color){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=color;
	sys_ExecuteByCodes(3,45);
}

//     .
void g_SetFillRGB(uint8_t red,uint8_t green,uint8_t blue){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=red;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=green;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=blue;
	sys_ExecuteByCodes(3,47);
}

//  .
uint32_t g_GetFillColor(void){
	return sys_ExecuteByCodesU32(3,46);
}

//  .     ,   "Clear".
void g_SetBackColor(uint32_t color){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=color;
	sys_ExecuteByCodes(3,11);
}

//     .
void g_SetBackRGB(uint8_t red,uint8_t green,uint8_t blue){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=red;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=green;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=blue;
	sys_ExecuteByCodes(3,12);
}


//   .
uint32_t g_GetBackColor(void){
	return sys_ExecuteByCodesU32(3,13);
}

//  .
uint32_t g_RandomColor(void){
	return sys_ExecuteByCodesU32(3,72);
}

//     (x)  (y)
void g_SetColorXY(int16_t x, int16_t y,uint32_t color){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=color;
	sys_ExecuteByCodes(3,14);
}

//     (x)  (y).
uint32_t g_GetColorXY(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	return sys_ExecuteByCodesU32(3,15);
}

//   .        (  ).
//      ,      (x2)  (y2).
void g_SetDrawRegion(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,16);
}

//  ,     (  ).
void g_SetMaxDrawRegion(void){
	sys_ExecuteByCodes(3,17);
}

//  (x)  (y)    ,   1.
//    g_SetDrawRegion  g_SetMaxDrawRegion
uint8_t g_CheckRegionXY(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	return sys_ExecuteByCodesU8(3,18);
}

//         .
void g_DrawPixel(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,19);
}

//    
void g_ClearPixel(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,20);
}

//    ,        .
void g_InvertPixel(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,21);
}

//     ,    .
void g_RandomPixel(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,22);
}

//       .
void g_DrawPoint(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,23);
}

//    
void g_FillRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,44);
}

//    
void g_ClearRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,25);
}

//    .
void g_InvertRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,43);
}

//   ,     g_RandomPixel
//    g_SetPenColor
void g_FillRectRandom(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,26);
}

//   (y1=y2)  (L)
void g_DrawLineH(int16_t x,int16_t y,int16_t L){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=L;
	sys_ExecuteByCodes(3,27);
}

//   (y1=y2)  (L)
void g_DrawLineV(int16_t x,int16_t y,int16_t L){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=L;
	sys_ExecuteByCodes(3,28);
}

//    
void g_DrawLine(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,29);
}

//     (x,y)  (width)   (height).
void g_DrawRectWH(int16_t x, int16_t y,int16_t width, int16_t height){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=width;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=height;
	sys_ExecuteByCodes(3,30);
}

//    .
void g_DrawRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,31);
}

//     .    g_SetPenColor,    g_SetFillColor
void g_DrawFillRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,24);
}

//      (x,y)  (width)   (height).
//   g_SetPenColor,    g_SetFillColor
void g_DrawFillRectWH(int16_t x, int16_t y,int16_t width, int16_t height){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=width;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=height;
	sys_ExecuteByCodes(3,51);
}

// 
void g_DrawCircle(int16_t x,int16_t y,int16_t R){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=R;
	sys_ExecuteByCodes(3,32);
}

//  .    g_SetPenColor,    g_SetFillColor.
void g_DrawFillCircle(int16_t x,int16_t y,int16_t R){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=R;
	sys_ExecuteByCodes(3,33);
}

// ,   .
void g_DrawEllipse(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,34);
}

//  ,   .    g_SetPenColor,    g_SetFillColor.
void g_DrawFillEllipse(int16_t x1, int16_t y1,int16_t x2, int16_t y2){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	sys_ExecuteByCodes(3,52);
}

//    
void g_DrawRoundRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2, int16_t r){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=r;
	sys_ExecuteByCodes(3,54);
}

//     
void g_DrawFillRoundRect(int16_t x1, int16_t y1,int16_t x2, int16_t y2, int16_t r){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=x2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=y2;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=r;
	sys_ExecuteByCodes(3,55);
}

//        
void g_DrawRoundRectWH(int16_t x, int16_t y,int16_t w, int16_t h, int16_t r){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=w;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=h;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=r;
	sys_ExecuteByCodes(3,35);
}

//         .
//   g_SetPenColor,    g_SetFillColor.
void g_DrawFillRoundRectWH(int16_t x, int16_t y,int16_t w, int16_t h, int16_t r){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=w;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=h;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=r;
	sys_ExecuteByCodes(3,53);
}


//        . (pitch) -    
// GetLastError()>0,  .
//(font=0) 7X5  
//(font=1) 7X5
//(font=2) 9X5
//(font=3) 9X8
//(font=4) 12X11
//(font=5) 14X11
//(font=6) 14X14
//(font=7) 16X16
void g_SetInternalFont(uint16_t font, int16_t pitch, uint16_t n){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=font;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=pitch;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+4)))=n;
	sys_ExecuteByCodes(3,36);
}

//   .
void g_SetTextColor(uint32_t color){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=color;
	sys_ExecuteByCodes(3,48);
}

//     .
void g_SetTextRGB(uint8_t red,uint8_t green,uint8_t blue){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=red;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=green;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=blue;
	sys_ExecuteByCodes(3,49);
}

//  .
uint32_t g_GetTextColor(void){
	return sys_ExecuteByCodesU32(3,50);
}

//    ( Windows)         (font_id).
//(height) -  , (bold=1) - , (italic=1) - , (underline=1) - , (strikeout=1) - .
//(name) -    Windows.  GetLastError()>0,  .
//   ,       ,  (font_id)   (0...255).
//   ,      g_SetExternalFont     (font_id).
void g_ConfigExternalFont(uint8_t font_id,uint16_t height, uint8_t bold, uint8_t italic, uint8_t underline,uint8_t strikeout,const char* name){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=font_id;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+1)))=height;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+3)))=bold;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+4)))=italic;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+5)))=underline;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+6)))=strikeout;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+7)))=(uint16_t)name;
	sys_ExecuteByCodes(3,37);
}

//       . 
void g_SetExternalFont(uint8_t font_id){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=font_id;
	sys_ExecuteByCodes(3,38);
}

//     
// GetLastError()>0,  .
void g_GetTextRect(int16_t *width, int16_t *height,const char *text){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)width;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)height;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+4)))=(uint16_t)text;
	sys_ExecuteByCodes(3,39);
}

//       .
//   x.
int16_t g_DrawText(int16_t x, int16_t y,const char *text){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+4)))=(uint16_t)text;
	return (int16_t)sys_ExecuteByCodesU16(3,40);
}

//     (x0)  (x1).
void g_DrawTextCenterX(int16_t x0, int16_t x1, int16_t y,const char *text){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=y;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+6)))=(uint16_t)text;
	sys_ExecuteByCodes(3,41);
}

//     (alpha).   (alpha),       (color2).
//  (alpha),       (color1).
uint32_t g_MixColors(uint8_t alpha,uint32_t color1,uint32_t color2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=alpha;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+1)))=color1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+5)))=color2;
	return sys_ExecuteByCodesU32(3,56);
}

//
void g_MoveTo(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,57);
}

//
void g_LineTo(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(3,58);
}

//
void g_SetArcDirection(uint8_t dir){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=dir;
	sys_ExecuteByCodes(3,62);
}

//
void g_DrawArc(int16_t left,int16_t top,int16_t right,int16_t bottom,int16_t startX,int16_t startY,int16_t endX,int16_t endY){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=left;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=top;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=right;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=bottom;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=startX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=startY;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=endX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+14)))=endY;
	sys_ExecuteByCodes(3,59);
}

//
void g_DrawChord(int16_t left,int16_t top,int16_t right,int16_t bottom,int16_t startX,int16_t startY,int16_t endX,int16_t endY){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=left;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=top;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=right;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=bottom;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=startX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=startY;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=endX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+14)))=endY;
	sys_ExecuteByCodes(3,64);
}

//
void g_DrawPie(int16_t left,int16_t top,int16_t right,int16_t bottom,int16_t startX,int16_t startY,int16_t endX,int16_t endY){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=left;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=top;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=right;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=bottom;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=startX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=startY;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=endX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+14)))=endY;
	sys_ExecuteByCodes(3,65);
}

//
void g_DrawArcTo(int16_t left,int16_t top,int16_t right,int16_t bottom,int16_t startX,int16_t startY,int16_t endX,int16_t endY){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=left;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=top;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=right;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=bottom;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=startX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=startY;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=endX;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+14)))=endY;
	sys_ExecuteByCodes(3,60);
}

//
void g_DrawAngleArc(int16_t x,int16_t y,int16_t radius,float startA,float sweep){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=radius;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+6)))=startA;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+10)))=sweep;
	sys_ExecuteByCodes(3,61);
}

//
void g_DrawBezier(int16_t x0,int16_t y0,int16_t cx0,int16_t cy0,int16_t cx1,int16_t cy1,int16_t x1,int16_t y1){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=cx0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=cy0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=cx1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=cy1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+14)))=y1;
	sys_ExecuteByCodes(3,63);
}

//
void g_SavePageToBMP(uint16_t pageN,const char* filepath){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)filepath;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=pageN;
	sys_ExecuteByCodes(3,66);
}

//
void g_SaveRectToBMP(const char* filepath,int16_t x0,int16_t y0,int16_t x1,int16_t y1){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)filepath;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=x0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=y0;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=x1;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=y1;
	sys_ExecuteByCodes(3,67);
}

//
void g_DrawBMP(const char* filepath,int16_t x,int16_t y){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)filepath;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=y;
	sys_ExecuteByCodes(3,68);
}

void g_CreatePageFromBMP(uint16_t pageN,const char* filepath){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)filepath;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=pageN;
	sys_ExecuteByCodes(3,77);
}

//
void g_GetSizeBMP(const char* filepath,int16_t* width,int16_t* height){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)filepath;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)width;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+4)))=(uint16_t)height;
	sys_ExecuteByCodes(3,69);
}


//
void g_CopyPage(uint16_t pageN,int16_t xsource,int16_t ysource,int16_t x,int16_t y,int16_t width,int16_t height){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=xsource;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=ysource;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+6)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+8)))=y;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+10)))=width;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+12)))=height;
	sys_ExecuteByCodes(3,70);
}


//     pageN   
void g_CreatePage(uint16_t pageN,int16_t width,int16_t height,uint8_t colors){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=width;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+4)))=height;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+6)))=colors;
	sys_ExecuteByCodes(3,73);
}

//     pageN
void g_DeletePage(uint16_t pageN){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	sys_ExecuteByCodes(3,74);
}

// 1,      pageN ,   0.
uint8_t g_GetPageStatus(uint16_t pageN){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	return sys_ExecuteByCodesU8(3,75);
}

//    .
uint16_t g_GetPageNum(void){
	return sys_ExecuteByCodesU16(3,76);
}

//   pageN
int16_t g_GetPageWidth(uint16_t pageN){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	return sys_ExecuteByCodesU16(3,78);
}

//   pageN
int16_t g_GetPageHeight(uint16_t pageN){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=pageN;
	return sys_ExecuteByCodesU16(3,79);
}

//      . (mode) -   .
//    g_SetFillColor  g_SetFillRGB.
// (mode=0),         .
// (mode=1),          .
//    g_SetBackColor  g_SetBackRGB.
void g_FloodFill(int16_t x,int16_t y,uint8_t mode){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+4)))=mode;
	sys_ExecuteByCodes(3,71);
}