/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

#include <stdio.h>
#include "nanonyam.h"
#include "nn_system_lib.h"
#include "nn_keyboard_lib.h"


//    .   ,  1.
uint8_t key_GetState(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,71);
}

// 1,             .
uint8_t key_GetDown(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,32);
}

// 1,             .
uint8_t key_GetUp(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,72);
}

// 1,            ,
//    1    .
uint8_t key_GetRepeat(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,37);
}

//          ( 10).
//  (codes)    .      10 .
// Shift, Ctrl, Alt    .
uint8_t key_GetArray(uint8_t* codes){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)codes;
	return sys_ExecuteByCodesU8(7,33);
}

// ,   key_GetArray,     
uint8_t key_GetArrayGlobal(uint8_t* codes){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)codes;
	return sys_ExecuteByCodesU8(7,105);
}

// 1,    
uint8_t key_GetBind(uint8_t ctrl,uint8_t shift,uint8_t alt,uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=ctrl;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=shift;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=alt;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+3)))=code;
	return sys_ExecuteByCodesU8(7,106);
}

// 1,    ,    
uint8_t key_GetBindGlobal(uint8_t ctrl,uint8_t shift,uint8_t alt,uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=ctrl;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=shift;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=alt;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+3)))=code;
	return sys_ExecuteByCodesU8(7,107);
}

// 1,  CapsLock 
uint8_t key_GetCapsLock(void){
	return sys_ExecuteByCodesU8(7,34);
}

// 1,  NumLock 
uint8_t key_GetNumLock(void){
	return sys_ExecuteByCodesU8(7,35);
}

// 1,  ScrollLock 
uint8_t key_GetScrollLock(void){
	return sys_ExecuteByCodesU8(7,36);
}

//       (code).     KeySendUp().
// 0,   .
uint8_t key_SendDown(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,38);
}

//       (code).
// 0,   .
uint8_t key_SendUp(uint8_t code){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=code;
	return sys_ExecuteByCodesU8(7,39);
}
