/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

#include <stdio.h>
#include <math.h>
#include "nanonyam.h"
#include "nn_system_lib.h"
#include "nn_math_lib.h"

//====Conversions====================================================
uint32_t math_FloatToU32(float x){
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR)))=x;
	return sys_ExecuteByCodesU32(9,23);
}

//====Arithmetic U32====================================================
uint32_t math_SumU32(uint32_t n1,uint32_t n2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesU32(9,1);
}

uint32_t math_SubU32(uint32_t n1,uint32_t n2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesU32(9,6);
}

uint32_t math_MulU32(uint32_t n1,uint32_t n2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesU32(9,11);
}

uint32_t math_DivU32(uint32_t n1,uint32_t n2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesU32(9,16);
}

uint32_t math_ModU32(uint32_t n1,uint32_t n2){
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesU32(9,21);
}
//====Arithmetic I32====================================================
int32_t math_SumI32(int32_t n1,int32_t n2){
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return (int32_t)sys_ExecuteByCodesU32(9,3);
}

int32_t math_SubI32(int32_t n1,int32_t n2){
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return (int32_t)sys_ExecuteByCodesU32(9,8);
}

int32_t math_MulI32(int32_t n1,int32_t n2){
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return (int32_t)sys_ExecuteByCodesU32(9,13);
}

int32_t math_DivI32(int32_t n1,int32_t n2){
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return (int32_t)sys_ExecuteByCodesU32(9,18);
}
//====Arithmetic U64====================================================
uint64_t math_SumU64(uint64_t n1,uint64_t n2){
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return sys_ExecuteByCodesU64(9,2);
}

uint64_t math_SubU64(uint64_t n1,uint64_t n2){
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return sys_ExecuteByCodesU64(9,7);
}

uint64_t math_MulU64(uint64_t n1,uint64_t n2){
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return sys_ExecuteByCodesU64(9,12);
}

uint64_t math_DivU64(uint64_t n1,uint64_t n2){
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return sys_ExecuteByCodesU64(9,17);
}

uint64_t math_ModU64(uint64_t n1,uint64_t n2){
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return sys_ExecuteByCodesU64(9,22);
}
//====Arithmetic I64====================================================
int64_t math_SumI64(int64_t n1,int64_t n2){
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return (int64_t)sys_ExecuteByCodesU64(9,4);
}

int64_t math_SubI64(int64_t n1,int64_t n2){
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return (int64_t)sys_ExecuteByCodesU64(9,9);
}

int64_t math_MulI64(int64_t n1,int64_t n2){
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return (int64_t)sys_ExecuteByCodesU64(9,14);
}

int64_t math_DivI64(int64_t n1,int64_t n2){
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile int64_t*)(START_SYSTEM_PARAM_ADDR+8)))=n2;
	return (int64_t)sys_ExecuteByCodesU64(9,19);
}

//====Arithmetic Float==================================================
float math_SumFLT(float n1,float n2){
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesFLT(9,5);
}

float math_SubFLT(float n1,float n2){
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesFLT(9,10);
}

float math_MulFLT(float n1,float n2){
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesFLT(9,15);
}

float math_DivFLT(float n1,float n2){
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR)))=n1;
	(*((volatile float*)(START_SYSTEM_PARAM_ADDR+4)))=n2;
	return sys_ExecuteByCodesFLT(9,20);
}

//====Random==============================================
//Random 0 ... 0xFF
uint8_t RandomU8(void){
	return sys_ExecuteByCodesU8(9,24);
}

//Random 0 ... 0xFFFF
uint16_t RandomU16(void){
	return sys_ExecuteByCodesU16(9,25);
}

//Random 0 ... 0xFFFFFFFF
uint32_t RandomU32(void){
	return sys_ExecuteByCodesU32(9,26);
}

//Random 0.0 ... 1.0
float RandomFLT(void){
	return sys_ExecuteByCodesFLT(9,27);
}

//Random (min)...(max)
int32_t RandomInterval(int32_t min, int32_t max){
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR)))=min;
	(*((volatile int32_t*)(START_SYSTEM_PARAM_ADDR+4)))=max;
	return sys_ExecuteByCodesU32(9,28);
}