/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

//Math functions for fast calculations

#ifndef __nanonyam_math_lib
#define __nanonyam_math_lib

//!!!Double==Float in AVR (4 bytes)

//Conversions
uint32_t math_FloatToU32(float x);

//n1+n2
uint32_t math_SumU32(uint32_t n1,uint32_t n2);
uint64_t math_SumU64(uint64_t n1,uint64_t n2);
int32_t math_SumI32(int32_t n1,int32_t n2);
int64_t math_SumI64(int64_t n1,int64_t n2);
float math_SumFLT(float n1,float n2);

//n1-n2
uint32_t math_SubU32(uint32_t n1,uint32_t n2);
uint64_t math_SubU64(uint64_t n1,uint64_t n2);
int32_t math_SubI32(int32_t n1,int32_t n2);
int64_t math_SubI64(int64_t n1,int64_t n2);
float math_SubFLT(float n1,float n2);

//n1*n2
uint32_t math_MulU32(uint32_t n1,uint32_t n2);
uint64_t math_MulU64(uint64_t n1,uint64_t n2);
int32_t math_MulI32(int32_t n1,int32_t n2);
int64_t math_MulI64(int64_t n1,int64_t n2);
float math_MulFLT(float n1,float n2);

//n1/n2
uint32_t math_DivU32(uint32_t n1,uint32_t n2);
uint64_t math_DivU64(uint64_t n1,uint64_t n2);
int32_t math_DivI32(int32_t n1,int32_t n2);
int64_t math_DivI64(int64_t n1,int64_t n2);
float math_DivFLT(float n1,float n2);

//n1%n2
uint32_t math_ModU32(uint32_t n1,uint32_t n2);
uint64_t math_ModU64(uint64_t n1,uint64_t n2);

//Random
uint8_t RandomU8(void);//Random 0 ... 0xFF
uint16_t RandomU16(void);//Random 0 ... 0xFFFF
uint32_t RandomU32(void);//Random 0 ... 0xFFFFFFFF
float RandomFLT(void);//Random 0.0 ... 1.0
int32_t RandomInterval(int32_t min, int32_t max);//Random (min)...(max)
#endif /*__nanonyam_math_lib*/
