/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

//Functions for the work with COM-port

#ifndef __nanonyam_rs232_lib
#define __nanonyam_rs232_lib

void rs232_Open(uint8_t portnum);
void rs232_Close(uint8_t portnum);
uint8_t rs232_TestPort(uint8_t portnum);
void rs232_Config(uint8_t portnum,uint32_t baudrate,uint8_t databits,uint8_t patity,uint8_t stopbits);
void rs232_SetTimeOut(uint8_t portnum,uint32_t timeout);
void rs232_Write(uint8_t portnum,uint16_t num,uint8_t *data);
void rs232_Read(uint8_t portnum,uint16_t num,uint8_t *data);
void rs232_WriteByte(uint8_t portnum,uint8_t data);
uint8_t rs232_ReadByte(uint8_t portnum);
uint8_t rs232_ReadCTS(uint8_t portnum);
uint8_t rs232_ReadDSR(uint8_t portnum);
uint8_t rs232_ReadRING(uint8_t portnum);
void rs232_ReadModemStatus(uint8_t portnum,uint8_t* cts, uint8_t* dsr,uint8_t* ring);
void rs232_WriteDTR(uint8_t portnum,uint8_t state);
void rs232_WriteRTS(uint8_t portnum,uint8_t state);
void rs232_PurgeTX(uint8_t portnum);
void rs232_PurgeRX(uint8_t portnum);
void rs232_PurgeRXTX(uint8_t portnum);
uint16_t rs232_GetNumRX(uint8_t portnum);
uint16_t rs232_GetNumTX(uint8_t portnum);

#endif /*__nanonyam_rs232_lib*/
