/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

#include <stdio.h>
#include "nanonyam.h"
#include "nn_system_lib.h"

//    ,      www.nanoslavic.com/donates
void Donates(void){
	(*((volatile uint8_t*)0x0049))=96;
	(*((volatile uint8_t*)0x0048))=7;
	asm volatile("break"::);
}

//     3   .
//   ,    .
//   ,       .
// sys_Nanonyam()      3 ,    .
void sys_Nanonyam(void){
	(*((volatile uint8_t*)0x0049))=70;
	(*((volatile uint8_t*)0x0048))=7;
	asm volatile("break"::);
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))+9;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))+7;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+1)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))+5;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+3)))+2;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+3)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+4)))+3;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+4)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+5)))+100;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+5)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+6)))+81;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+6)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+7)))+63;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+7)))=(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+8)));
	(*((volatile uint8_t*)0x0048))=1;
	asm volatile("break"::);
}

//     .
// sys_Work()      .
void sys_Work(void){
	asm volatile("wdr"::);
	while ((*((volatile uint8_t*)0x0046))>0){
		(*((volatile uint8_t*)0x0048))=11;//LoadNext
		asm volatile("break"::);
		((InterruptCall_t)(*((volatile uint16_t*)0x0044)))();
		};
}

//   .     sys_Work().
//   Delay_ms   .
void sys_Delay(uint32_t t){
	uint32_t count;
	sys_GetCountShift(&count,t);
	while (sys_CompareCount(&count)==0){
		sys_Work();
		(*((volatile uint8_t*)0x0048))=0x02;
		asm volatile("break"::);
		};
}


void sys_ExecuteByCodes(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
}

uint8_t sys_ExecuteByCodesU8(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
	return (*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)));
}

uint16_t sys_ExecuteByCodesU16(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
	return (*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)));
}

uint32_t sys_ExecuteByCodesU32(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
	return (*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR)));
}

uint64_t sys_ExecuteByCodesU64(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
	return (*((volatile uint64_t*)(START_SYSTEM_PARAM_ADDR)));
}

float sys_ExecuteByCodesFLT(uint8_t a, uint8_t b){
	(*((volatile uint8_t*)0x0049))=b;
	(*((volatile uint8_t*)0x0048))=a;
	asm volatile("break"::);
	return (*((volatile float*)(START_SYSTEM_PARAM_ADDR)));
}




//  .
void sys_InterruptCollectOn(void){
	(*((volatile uint8_t*)0x0048))=12;
	asm volatile("break"::);	
}

//  .    .
void sys_InterruptCollectOff(void){
	(*((volatile uint8_t*)0x0048))=13;
	asm volatile("break"::);	
}

//   .
void sys_InterruptWorkOn(void){
	asm volatile("sei"::);
}

//   .
void sys_InterruptWorkOff(void){
	asm volatile("cli"::);
}

//     
uint16_t sys_InterruptGetNumber(void){
	return sys_ExecuteByCodesU16(7,20);
}

//  
void sys_InterruptClear(void){
	sys_ExecuteByCodes(7,19);
}


//    (int_type).
// (callback)     .
// (int_type=INT_Timer -    ),        (callback=0).
//     ,     CreateTimer()
//  ,       0.
//   >0.
uint8_t sys_InterruptLink(uint16_t int_type,InterruptCall_t callback){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=int_type;
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2))=(uint16_t)callback;
	return sys_ExecuteByCodesU8(7,14);
}

//    (int_type).  0,   .
//   >0.
uint8_t sys_InterruptOn(uint16_t int_type){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=int_type;
	return sys_ExecuteByCodesU8(7,15);
}

//    (int_type).  0,   .
//   >0.
uint8_t sys_InterruptOff(uint16_t int_type){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=int_type;
	return sys_ExecuteByCodesU8(7,16);
}

// 1,     (int_type) .   0.
uint8_t sys_InterruptGetState(uint16_t int_type){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=int_type;
	return sys_ExecuteByCodesU8(7,17);
}

//     
void sys_GetDateTime(sys_DateTime_t *t){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=(uint16_t)t;
	sys_ExecuteByCodes(7,1);
}

//    
void sys_SetDateTime(sys_DateTime_t *t){
	(*(volatile uint16_t*)(START_SYSTEM_PARAM_ADDR))=(uint16_t)t;
	sys_ExecuteByCodes(7,31);
}

//  
void sys_GetTime(sys_Time_t *t){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)t;
	sys_ExecuteByCodes(7,2);
}

//  
void sys_GetDate(sys_Date_t *t){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)t;
	sys_ExecuteByCodes(7,3);
}

//    
void sys_GetInfo(sys_Info_t* info){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)info;
	sys_ExecuteByCodes(7,4);
}

//     
void sys_GetDateTimeUTC(sys_DateTime_t *t){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)t;
	sys_ExecuteByCodes(7,5);
}

//  
void sys_GetTimeUTC(sys_Time_t *t){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)t;
	sys_ExecuteByCodes(7,6);
}

//  
void sys_GetDateUTC(sys_Date_t *t){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)t;
	sys_ExecuteByCodes(7,7);
}

//  ,   
void sys_WindowSetNormal(void){
	sys_ExecuteByCodes(7,8);
}

//  ,   
void sys_WindowSetMin(void){
	sys_ExecuteByCodes(7,9);
}

//   ,  1,  0.
uint8_t sys_WindowGetMin(void){
	return sys_ExecuteByCodesU8(7,10);
}

//  (text)   
void sys_WindowSetText(const char* text){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)text;
	sys_ExecuteByCodes(7,18);
}

//  ( )
void sys_WindowFlash(void){
	sys_ExecuteByCodes(7,21);
}

//  
//z=0 -    
//z=1 -    ,       
//z=2 -    ,       
//z=3 -            
void sys_WindowSetZ(uint8_t z){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=z;
	sys_ExecuteByCodes(7,25);
}

// 
void sys_WindowShow(void){
	sys_ExecuteByCodes(7,22);
}

// 
void sys_WindowHide(void){
	sys_ExecuteByCodes(7,23);
}

//     
void sys_WindowSetXY(int16_t x, int16_t y){
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR)))=x;
	(*((volatile int16_t*)(START_SYSTEM_PARAM_ADDR+2)))=y;
	sys_ExecuteByCodes(7,24);
}

//  (width)   (height) 
void sys_WindowGetSize(int16_t *width, int16_t *height){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)width;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)height;
	sys_ExecuteByCodes(7,27);
}

//     
void sys_WindowGetXY(int16_t *x, int16_t *y){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)x;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)y;
	sys_ExecuteByCodes(7,28);
}

//    
void sys_WindowSetToCenter(void){
	sys_ExecuteByCodes(7,29);
}

//  (width)   (height)  
void sys_GetMonitorSize(int16_t *width, int16_t *height){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)width;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)height;
	sys_ExecuteByCodes(7,30);
}

//     (F)   (T)
void sys_Beep(uint16_t F, uint16_t T){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=F;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=T;
	return sys_ExecuteByCodes(7,26);
}

//        .
// Windows   .
uint32_t sys_GetCount(void){
	return sys_ExecuteByCodesU32(7,11);
}

//   (count)      (shift).
//    CompareSysTimer()     .
void sys_GetCountShift(uint32_t* count,uint32_t shift){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)count;
	(*((volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+2)))=shift;
	sys_ExecuteByCodes(7,12);
}

//  (count)     sys_GetCount().
// 0,  (sys_GetCount()<(count))
// 1,  (sys_GetCount()==(count))
// 2,  (sys_GetCount()>(count))
//       , :
//uint32_t timer_save;
//sys_GetCountShift(&timer_save,100);//   +100 
//while(1){
//	if (sys_CompareCount(&timer_save)>0){
//		sys_GetCountShift(&timer_save,100);
//		//-    
//		};
//};//While(1)
uint8_t sys_CompareCount(uint32_t* count){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)count;
	return sys_ExecuteByCodesU8(7,13);
}

//      (message)   (title).
//(buttons=0) -   "" 
//(buttons=1) -  ""  ""
//(buttons=2) -  ""  ""
//(buttons=3) -  "", ""  ""
//:
//0 - ; 1 -   ""; 2 - ""; 3 - ""; 4 - ""
// GetLastError()>0,  .
uint8_t sys_MessageBox(const char* title,const char* message,uint8_t buttons){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)message;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)title;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+4)))=buttons;
	return sys_ExecuteByCodesU8(7,65);
}

//  
void sys_ProgramExit(void){
	sys_ExecuteByCodes(7,66);
}

// ,      .
//  (autoexit=0),     "",    ,
//    INT_ProgramClose     ProgramExit()  .
// (autoexit=1)     .
void sys_SetAutoExit(uint8_t autoexit){
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR)))=autoexit;
	sys_ExecuteByCodes(7,67);
}

//    
void sys_CursorGetXY(int16_t* mX,int16_t* mY){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)mX;
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR+2)))=(uint16_t)mY;
	sys_ExecuteByCodes(7,92);
}

//    
void sys_CursorShow(void){
	sys_ExecuteByCodes(7,93);
}

//    
void sys_CursorHide(void){
	sys_ExecuteByCodes(7,94);
}

//  (interval) ()     (timerNum=0..7).
//     INT_Timer0...INT_Timer7,        .
//    InterruptCollectOn()  InterruptLink().  GetLastError()>0,  .
// Windows     ,        .
void sys_SetTimerInterval(uint8_t timerNum, uint32_t interval){
	(*(volatile uint8_t*)(START_SYSTEM_PARAM_ADDR))=timerNum;
	(*(volatile uint32_t*)(START_SYSTEM_PARAM_ADDR+1))=interval;
	sys_ExecuteByCodes(7,95);
}

uint8_t sys_WindowGetFocus(void){
	return sys_ExecuteByCodesU8(7,97);
}

//  .  show=0,     ,  =1,  
void sys_RunComLine(const char* text,uint8_t show){
	(*((volatile uint16_t*)(START_SYSTEM_PARAM_ADDR)))=(uint16_t)text;
	(*((volatile uint8_t*)(START_SYSTEM_PARAM_ADDR+2)))=show;
	sys_ExecuteByCodes(7,104);
}

