/*
  Nanonyam
  Copyright (C) 2020 Nanoslavic
  www.nanoslavic.ru/nanonyam
  www.nanoslavic.com/nanonyam
  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/ 

//Functions for strings

#ifndef __nanonyam_text_lib
#define __nanonyam_text_lib

inline void str_Clear(char* text);
uint16_t str_Size(const char* text);
uint16_t str_Load(char* text,const char* load);
uint16_t str_LoadToEnd(char* text,const char* load);
uint16_t str_Copy(char* to_str,const char* from_str);
void str_ToLower(char* text);
void str_ToUpper(char* text);
uint16_t str_FindChar(char* text,char c);
uint16_t str_FindText(char* text,const char* find);
uint16_t str_ReplaceChar(char* text,char c,char cr);
uint16_t str_DeleteN(char* text,uint16_t n0,uint16_t n);
uint16_t str_DeleteChar(char* text,char c);
uint16_t str_InsertCharN(char* text,uint16_t n, char c);
void str_Reverse(char* text);
void str_OnlyAfterLast(char* text,char c);
void str_OnlyAfter(char* text,char c);
void str_OnlyBeforeLast(char* text,char c);
void str_OnlyBefore(char* text,char c);
void str_OnlyBetween(char* text,char c0,char c1);
void str_OnlyBeforeAndAfter(char* text,char c0,char c1);
void str_OnlyFileNameExt(char* path);
void str_OnlyFileName(char* path);
void str_OnlyFileExt(char* path);
void str_OnlyFileDir(char* path);

uint16_t str_U16ToText(char* text,uint8_t z,uint16_t numeric);
uint16_t str_U32ToText(char* text,uint8_t z,uint32_t numeric);
uint16_t str_U64ToText(char* text,uint8_t z,uint64_t numeric);
uint16_t str_I16ToText(char* text,uint8_t z,int16_t numeric);
uint16_t str_I32ToText(char* text,uint8_t z,int32_t numeric);
uint16_t str_I64ToText(char* text,uint8_t z,int64_t numeric);

uint16_t str_FloatToText(char* text,uint8_t n,float x);

uint16_t str_U8ToHex(char* text,uint8_t numeric);
uint16_t str_U16ToHex(char* text,uint16_t numeric);
uint16_t str_U32ToHex(char* text,uint32_t numeric);
uint16_t str_U64ToHex(char* text,uint64_t numeric);

int32_t str_ToI32(char* text);
int64_t str_ToI64(char* text);
float str_ToFloat(char* text);


#endif /*__nanonyam_text_lib*/
